;This program was written by vkim
;vkim@aport2000.ru
;-----------------------------------------------------------------------------
;WinMain procedure based on Iczelion's code

.386
.model flat, stdcall
option casemap: none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\masm32.inc
include \masm32\include\comctl32.inc
include \masm32\debug\dbgwin\registry\Registry.inc
include macro.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\debug\dbgwin\registry\Registry.lib

WinMain proto :dword, :dword, :dword, :dword

.data
hEdit dword 0
procOld dword 0
hInstance dword 0
hTbr dword 0
dwStyle dword 0
tbb TBBUTTON 2 dup (<>)
tbab TBADDBITMAP <>
szClassName byte "WinClass", 0
szWinName byte "WinName", 0
szTipTop byte "Topmost", 0
szTipClear byte "Clear", 0
szTipHelp byte "Help", 0
szHelpPath byte "\masm32\help\dbgwin.hlp", 0

.data?
dwCommandLine dword ?

.const
DebugText equ 1102

.code
start:
    invoke GetModuleHandle, NULL
    mov hInstance, eax
    invoke GetCommandLine
    mov dwCommandLine, eax
    invoke InitCommonControls
    invoke WinMain, hInstance, NULL, dwCommandLine, SW_SHOWDEFAULT
    invoke ExitProcess, eax

WndProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM
    local rt: RECT
    local top: dword
    local left: dword
    local wth: dword
    local hgt: dword
    local state: dword
    .if uMsg == WM_DESTROY
        ;save settings - position and state
        invoke GetWindowRect, hWnd, addr rt
        invoke SetRegDword, HKEY_LOCAL_MACHINE,
                CTEXT("Software\MASM32\DbgWin\"),
                CTEXT("top"),
                rt.top
        invoke SetRegDword, HKEY_LOCAL_MACHINE,
                CTEXT("Software\MASM32\DbgWin\"),
                CTEXT("left"),
                rt.left
        mov eax, rt.right
        sub eax, rt.left
        mov wth, eax
        invoke SetRegDword, HKEY_LOCAL_MACHINE,
                CTEXT("Software\MASM32\DbgWin\"),
                CTEXT("width"),
                wth
        mov eax, rt.bottom
        sub eax, rt.top
        mov hgt, eax
        invoke SetRegDword, HKEY_LOCAL_MACHINE,
                CTEXT("Software\MASM32\DbgWin\"),
                CTEXT("height"),
                hgt
        invoke SendMessage, hTbr, TB_GETSTATE, 1, 0
        mov state, eax
        invoke SetRegDword, HKEY_LOCAL_MACHINE,
                CTEXT("Software\MASM32\DbgWin\"),
                CTEXT("state"),
                state
        ;and terminate window
        invoke PostQuitMessage, NULL
    .elseif uMsg == WM_SIZE
        ;move the edit and change size of the toolbar
        mov eax, lParam
        push eax
        and eax, 0FFFFh
        mov wth, eax
        pop eax
        rol eax, 16
        and eax, 0FFFFh
        mov hgt, eax
        sub hgt, 27
        invoke MoveWindow, hEdit, 0, 27, wth, hgt, TRUE
        invoke SendMessage, hTbr, TB_AUTOSIZE, 0, 0
    .elseif uMsg == WM_CREATE
        ;create toolbar
        mov tbb.iBitmap, 0
        mov tbb.idCommand, 1
        mov tbb.fsState, TBSTATE_ENABLED 
        mov tbb.fsStyle, TBSTYLE_CHECK
        mov tbb._wPad1, 0
        mov tbb.dwData, 0
        mov tbb.iString, 0
        invoke CreateToolbarEx, hWnd, WS_CHILD+TBSTYLE_TOOLTIPS+WS_VISIBLE+TBSTYLE_FLAT, 1, 0, hInstance, 129, addr tbb, 1, 0, 0, 16, 16, sizeof TBBUTTON
        mov hTbr, eax
        ;add sep button
        mov tbb.iBitmap, 0
        mov tbb.fsStyle, TBSTYLE_SEP
        invoke SendMessage, hTbr, TB_ADDBUTTONS, 1, addr tbb
        ;add bitmap into the toolbar image list
        m2m tbab.hInst, hInstance
        mov tbab.nID, 130
        invoke SendMessage, hTbr, TB_ADDBITMAP, 1, addr tbab

        m2m tbab.hInst, hInstance
        mov tbab.nID, 131
        invoke SendMessage, hTbr, TB_ADDBITMAP, 1, addr tbab

        ;add clear button
        mov tbb.iBitmap, 1
        mov tbb.idCommand, 2
        mov tbb.fsState, 4
        mov tbb.fsStyle, TBSTYLE_BUTTON
        invoke SendMessage, hTbr, TB_ADDBUTTONS, 1, addr tbb

        ;add help button
        mov tbb.iBitmap, 2
        mov tbb.idCommand, 3
        mov tbb.fsState, 4
        mov tbb.fsStyle, TBSTYLE_BUTTON
        invoke SendMessage, hTbr, TB_ADDBUTTONS, 1, addr tbb
    .elseif uMsg == WM_INITDIALOG
        ;get settings - position and state (topmost or not topmost)
        invoke GetRegDword, HKEY_LOCAL_MACHINE, 
            CTEXT("Software\MASM32\DbgWin\"), 
            CTEXT("top"), 
            addr top
        .if eax != ERROR_SUCCESS ;if err then set default
            mov top, 0
        .endif  
        invoke GetRegDword, HKEY_LOCAL_MACHINE,
            CTEXT("Software\MASM32\DbgWin\"),
            CTEXT("left"),
            addr left
        .if eax != ERROR_SUCCESS
            mov left, 0
        .endif
        invoke GetRegDword, HKEY_LOCAL_MACHINE,
            CTEXT("Software\MASM32\DbgWin\"),
            CTEXT("width"),
            addr wth
        .if eax != ERROR_SUCCESS
            mov wth, 250
        .endif
        invoke GetRegDword, HKEY_LOCAL_MACHINE,
            CTEXT("Software\MASM32\DbgWin\"),
            CTEXT("height"),
            addr hgt
        .if eax != ERROR_SUCCESS
            mov hgt, 250
        .endif
        invoke GetRegDword, HKEY_LOCAL_MACHINE,
            CTEXT("Software\MASM32\DbgWin\"),
            CTEXT("state"),
            addr state
        .if eax != ERROR_SUCCESS
            mov state, 5
        .endif
        .if state == 5 ; if a button must be checked
            invoke SetWindowPos, hWnd, HWND_TOPMOST, 0, 0, 0, 0, 3
        .else
            invoke SetWindowPos, hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, 3
        .endif
        invoke PostMessage, hTbr, TB_SETSTATE, 1, state ;check button
        invoke MoveWindow, hWnd, left, top, wth, hgt, TRUE ;move main window by read settings

        ;move edit window and subclass it
        invoke GetDlgItem, hWnd, DebugText  
        mov hEdit, eax
        invoke GetClientRect, hWnd, addr rt
        mov eax, rt.right
        sub eax, rt.left
        mov wth, eax
        mov eax, rt.bottom
        sub eax, rt.top
        mov hgt, eax
        sub hgt, 27
        invoke SetWindowLongA, hEdit, GWL_WNDPROC, ADDR EditWndProc
        mov procOld, eax
        invoke MoveWindow, hEdit, 0, 27, wth, hgt, TRUE
        invoke ShowWindow, hWnd, SW_SHOWNORMAL
        invoke UpdateWindow, hWnd
    .elseif uMsg == WM_COMMAND
        .if wParam == 1
            invoke SendMessage, hTbr, TB_GETSTATE, 1, 0
            .if eax == 5 ;checked
                invoke SetWindowPos, hWnd, HWND_TOPMOST, 0, 0, 0, 0, 3
            .elseif eax == 4 ;not checked   
                invoke SetWindowPos, hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, 3
            .endif
        .elseif wParam == 2 ;clear TextBox
            invoke SendMessage, hEdit, WM_SETTEXT, 0, 0
        .elseif wParam == 3 ;if the calc button pressed
            invoke WinHelp, hWnd, addr szHelpPath, HELP_CONTENTS, 0
        .endif
    .elseif (uMsg == WM_KEYDOWN) && (wParam == VK_F1)
        invoke WinHelp, hWnd, addr szHelpPath, HELP_CONTENTS, 0
    .elseif uMsg == WM_NOTIFY ;trap message for tooltips
        mov eax,[lParam]
        assume eax: ptr TOOLTIPTEXT
        .if [eax].hdr.code == TTN_NEEDTEXT
            .if [eax].hdr.idFrom == 1
                mov [eax].lpszText, offset szTipTop
            .elseif [eax].hdr.idFrom == 2
                mov [eax].lpszText, offset szTipClear
            .elseif [eax].hdr.idFrom == 3
                mov [eax].lpszText, offset szTipHelp
            .endif
        .endif
        assume eax: nothing
    .else
        invoke DefWindowProc, hWnd, uMsg, wParam, lParam
        jmp ext
    .endif
    xor eax, eax
ext:
    ret
WndProc endp

WinMain proc hInst: dword, hPrevInst: dword, CommandLine: dword, CmdShow: dword
    local wc: WNDCLASSEX
    local msg: MSG
    local hwnd: dword
    mov wc.cbSize, sizeof WNDCLASSEX
    mov wc.style, CS_HREDRAW or CS_VREDRAW
    mov wc.lpfnWndProc, offset WndProc
    mov wc.cbClsExtra, NULL
    mov wc.cbWndExtra, DLGWINDOWEXTRA
    push hInst
    pop wc.hInstance
    mov wc.hbrBackground, COLOR_BTNFACE + 1
    mov wc.lpszMenuName, NULL
    mov wc.lpszClassName, offset szClassName
    invoke LoadIcon, hInstance, 1
    mov wc.hIcon, eax
    invoke LoadCursor, NULL, IDC_ARROW
    mov wc.hCursor, eax
    mov wc.hIconSm, NULL
    invoke RegisterClassEx, addr wc
    invoke CreateDialogParam, hInstance, addr szWinName, NULL, addr WndProc, NULL
    mov hwnd, eax
    .while TRUE
        invoke GetMessage, addr msg, NULL, 0, 0
        .break .if (!eax)
        invoke IsDialogMessage, hwnd, addr msg
        .if eax == FALSE
            invoke TranslateMessage, addr msg
            invoke DispatchMessage, addr msg
        .endif
    .endw
    mov eax, msg.wParam
    ret
WinMain endp

EditWndProc proc hwnd: dword, uMsg: dword, wParam: dword, lParam: dword
    .if uMsg == WM_KEYDOWN
        .if wParam == VK_A
            invoke GetAsyncKeyState, VK_CONTROL
            sub ax, 0
            .if sign? ;check if ax < 0
                invoke SendMessage, hEdit, EM_SETSEL, NULL, -1
            .endif
        .elseif wParam == VK_F1
            invoke WinHelp, hEdit, addr szHelpPath, HELP_CONTENTS, 0
        .endif
    .endif  
    invoke CallWindowProc, procOld, hEdit, uMsg, wParam, lParam
    ret
EditWndProc endp

end start     